From dcc1db841ebfb3cb36dc869854e3370713e3b144 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 27 2021 19:25:48 +0000
Subject: [PATCH 2066/2232] Add regression test of let_cxx_string in async fn


    error: future cannot be sent between threads safely
      --> tests/cxx_string.rs:14:5
       |
    13 |     fn assert_send(_: impl Send) {}
       |                            ---- required by this bound in `assert_send`
    14 |     assert_send(f());
       |     ^^^^^^^^^^^ future returned by `f` is not `Send`
       |
       = help: within `impl Future`, the trait `Send` is not implemented for `*const ()`
    note: future is not `Send` as this value is used across an await
      --> tests/cxx_string.rs:9:9
       |
    6  |         let_cxx_string!(s = "...");
       |         --------------------------- has type `StackString` which is not `Send`
    ...
    9  |         g(&s).await;
       |         ^^^^^^^^^^^ await occurs here, with `mut $var` maybe used later
    10 |     }
       |     - `mut $var` is later dropped here

---

diff --git a/tests/cxx_string.rs b/tests/cxx_string.rs
new file mode 100644
index 0000000..be693cd
--- /dev/null
+++ b/tests/cxx_string.rs
@@ -0,0 +1,15 @@
+use cxx::{let_cxx_string, CxxString};
+
+#[test]
+fn test_async_cxx_string() {
+    async fn f() {
+        let_cxx_string!(s = "...");
+
+        async fn g(_: &CxxString) {}
+        g(&s).await;
+    }
+
+    // https://github.com/dtolnay/cxx/issues/693
+    fn assert_send(_: impl Send) {}
+    assert_send(f());
+}

